function browseFoldersDialog(targetInput) {
	targetInput=$(targetInput);
	var filemanager = $('.filemanager'),
		breadcrumbs = $('.breadcrumbs'),
		fileList = filemanager.find('.data');

	// Start by fetching the file data from scan.php with an AJAX request

	$.get('/command.php?command=list_dirs', function(data) {

		var response = [data],
			currentPath = '',
			breadcrumbsUrls = [];

		var folders = [],
			files = [];
		
		console.log("browseFoldersDialog/data=",data);

		// This event listener monitors changes on the URL. We use it to
		// capture back/forward navigation in the browser.

		$(window).on('hashchange', function(){

			goto(window.location.hash);

			// We are triggering the event. This will execute 
			// this function on page load, so that we show the correct folder:

		}).trigger('hashchange');


		// Hiding and showing the search box

		filemanager.find('.search,.mkdir').click(function(){

			var parent = $(this);

			//search.find('span').hide();
			parent.find('span').css("display","block");
			parent.find("input[type=search],input[type=mkdir]").focus();

		});


		// Listening for keyboard input on the search field.
		// We are using the "input" event which detects cut and paste
		// in addition to keyboard input.

		filemanager.find('input[type=search]').on('input', function(e){

			folders = [];
			files = [];

			var value = this.value.trim();

			if(value.length) {

				filemanager.addClass('searching');

				// Update the hash on every key stroke
				window.location.hash = 'search=' + value.trim();

			}

			else {

				filemanager.removeClass('searching');
				window.location.hash = encodeURIComponent(currentPath);

			}

		}).on('keyup', function(e){

			// Clicking 'ESC' button triggers focusout and cancels the search

			var search = $(this);

			if(e.keyCode == 27) {

				search.trigger('focusout');

			}

		}).focusout(function(e){
			var btn=$(this);
			// Cancel the search
			setTimeout(function() {
				var search = btn;

				if(!search.val().trim().length) {

					window.location.hash = encodeURIComponent(currentPath);
					var parent=$(this).parents("div").first();
					parent.find("span").hide();
					//search.parents("search").first().find('span').show();

				}
			},1000);
		});
		
		filemanager.find('input[type=mkdir]').focusout(function(ev) {
			var btn=$(this);
			setTimeout(function() {
				var parent=btn.parents(".mkdir").first();
				parent.find("span").hide();
			},1000);
		});
		
		filemanager.find(".selectFolderBtn").on("click",function(ev) {
			if (currentPath!="/") {
				targetInput.val(currentPath);
				var modal=$(this).parents("div.modal").first();
				modal.modal("hide");
			}
		});
		
		filemanager.find('div.mkdir button.btn-success').on("click",function(ev) {
			var parent=$(this).parents("div").first();
			var input=parent.find("input[type=mkdir]");
			var folder=input.val();
			
			if (folder.trim()=="")
				return;
			
			var path=currentPath+"/"+folder;
			
			$.get('/command.php?command=mkdir&dir='+encodeURIComponent(path), function(data) {
				searchByPath(response,currentPath,function(demo) {
					var found=searchByPath([demo],path,function(demo) {
						// Was the folder already present?
					});
					if (!found) {
						demo.push({	name	:	folder,
									type	:	"folder",
									path	:	path,
								  });
					}
					setTimeout(function() {
						input.val("");
						input.focusout();
						$(window).trigger("hashchange");
						//window.location.hash = encodeURIComponent(path);
					},1000);
				});
			});
		});


		// Clicking on folders

		fileList.on('click', 'li.folders', function(e){
			e.preventDefault();

			var nextDir = $(this).find('a.folders').attr('href');

			if(filemanager.hasClass('searching')) {

				// Building the breadcrumbs

				breadcrumbsUrls = generateBreadcrumbs(nextDir);

				filemanager.removeClass('searching');
				filemanager.find('input[type=search]').val('').hide();
				filemanager.find('span').show();
			}
			else {
				breadcrumbsUrls.push(nextDir);
			}

			window.location.hash = encodeURIComponent(nextDir);
			currentPath = nextDir;
		});


		// Clicking on breadcrumbs

		breadcrumbs.on('click', 'a', function(e){
			e.preventDefault();

			var index = breadcrumbs.find('a').index($(this)),
				nextDir = breadcrumbsUrls[index];

			breadcrumbsUrls.length = Number(index);

			window.location.hash = encodeURIComponent(nextDir);

		});


		// Navigates to the given hash (path)

		function goto(hash) {

			console.log("browseFoldersDialog/hash="+hash);
			
			hash = decodeURIComponent(hash).slice(1).split('=');
			
			if (!hash.length)
				hash=["",""];
			console.log("browseFoldersDialog/decoded hash=",hash);
			
			var rendered = '';

			// if hash has search in it

			if (hash[0] === 'search') {

				filemanager.addClass('searching');
				rendered = searchData(response, hash[1].toLowerCase());

				if (rendered.length) {
					currentPath = hash[0];
					render(rendered);
				}
				else {
					render(rendered);
				}

			}

			// if hash is some path

			else if (hash[0].trim().length) {
				console.log("browseFoldersDialog/currentPath="+currentPath+"/hash[0]="+hash[0]);
				searchByPath(response,hash[0],function(demo) {
					rendered = demo;
					console.log("browseFoldersDialog/rendered=",rendered);

					if (rendered.length) {

						currentPath = hash[0];
						breadcrumbsUrls = generateBreadcrumbs(hash[0]);
						render(rendered);

					}
					else {
						currentPath = hash[0];
						breadcrumbsUrls = generateBreadcrumbs(hash[0]);
						render(rendered);
					}
				});
			}
			// if there is no hash
			else {
				currentPath = data.path;
				breadcrumbsUrls.push(data.path);
				searchByPath(response,data.path,function(demo) {
					var search=demo;
					console.log("browseFoldersDialog/currentPath="+currentPath+"/search=",search);
					render(search);
				});
			}
			
			if (currentPath=="/")
				filemanager.find(".selectFolderBtn").addClass("disabled");
			else
				filemanager.find(".selectFolderBtn").removeClass("disabled");
		}

		// Splits a file path and turns it into clickable breadcrumbs

		function generateBreadcrumbs(nextDir){
			var path = nextDir.split('/').slice(0);
			for(var i=1;i<path.length;i++){
				path[i] = path[i-1]+ '/' +path[i];
			}
			path[0]="/";
			return path;
		}


		// Locates a file by path

		function searchByPath(data,dir,callback) {
			/*var path = 	dir=='/'
						?	[]	
						:	dir.split('/'),
				demo = response,
				flag = 0;
			

			for(var i=0;i<path.length;i++){
				for(var j=0;j<demo.length;j++){
					if(demo[j].name === path[i]){
						flag = 1;
						demo = demo[j].items;
						break;
					}
				}
			}*/
			
			var demo = data,
				flag = 0;
			
			for(var j=0;j<demo.length;j++){
				if (demo[j].path === dir) {
					flag = 1;
					if (currentPath==dir/* && !demo[j].items*/) {
						$.get('/command.php?command=list_dirs&dir='+encodeURIComponent(dir), function(data) {
							demo[j].items=data.items;
							callback(demo[j].items);
						});
					} else {
						callback(demo[j].items);
					}
					break;
				} else
				if (demo[j].type == "folder" && dir.indexOf(demo[j].path)==0) {
					if (!demo[j].items) {
						$.get('/command.php?command=list_dirs&dir='+encodeURIComponent(dir), function(data) {
							demo[j].items=data.items;
							searchByPath(demo[j].items,dir,callback);
						});
					} else {
						searchByPath(demo[j].items,dir,callback);
					}
				}
			}
			
			return flag;

			/*demo = flag ? demo : [];
			return demo;*/
		}


		// Recursively search through the file tree

		function searchData(data, searchTerms) {

			data.forEach(function(d){
				if(d.type === 'folder') {

					searchData(d.items,searchTerms);

					if(d.name.toLowerCase().match(searchTerms)) {
						folders.push(d);
					}
				}
				else if(d.type === 'file') {
					if(d.name.toLowerCase().match(searchTerms)) {
						files.push(d);
					}
				}
			});
			return {folders: folders, files: files};
		}


		// Render the HTML for the file manager

		function render(data) {

			var scannedFolders = [],
				scannedFiles = [];

			if(Array.isArray(data)) {

				data.forEach(function (d) {

					if (d.type === 'folder') {
						scannedFolders.push(d);
					}
					else if (d.type === 'file') {
						scannedFiles.push(d);
					}

				});

			}
			else if(typeof data === 'object') {

				scannedFolders = data.folders;
				scannedFiles = data.files;

			}
			
			// Empty the old result and make the new one

			fileList.empty().hide();

			if(!scannedFolders.length && !scannedFiles.length) {
				filemanager.find('.nothingfound').show();
			}
			else {
				filemanager.find('.nothingfound').hide();
			}

			if(scannedFolders.length) {

				scannedFolders.forEach(function(f) {

					var itemsLength = (f.items ? f.items.length : 0),
						name = escapeHTML(f.name),
						icon = '<span class="icon folder"></span>';

					if(itemsLength) {
						icon = '<span class="icon folder full"></span>';
					}

					if(itemsLength == 1) {
						itemsLength += ' item';
					}
					else if(itemsLength > 1) {
						itemsLength += ' items';
					}
					else {
						itemsLength = f.items ? 'Empty' : '?';
					}

					var folder = $('<li class="folders"><a href="'+ f.path +'" title="'+ f.path +'" class="folders">'+icon+'<span class="name">' + name + '</span> <span class="details">' + itemsLength + '</span></a></li>');
					folder.appendTo(fileList);
				});

			}

			if(scannedFiles.length) {

				scannedFiles.forEach(function(f) {

					var fileSize = bytesToSize(f.size),
						name = escapeHTML(f.name),
						fileType = name.split('.'),
						icon = '<span class="icon file"></span>';

					fileType = fileType[fileType.length-1];

					icon = '<span class="icon file f-'+fileType+'">.'+fileType+'</span>';

					var file = $('<li class="files"><a href="'+ f.path+'" title="'+ f.path +'" class="files">'+icon+'<span class="name">'+ name +'</span> <span class="details">'+fileSize+'</span></a></li>');
					file.appendTo(fileList);
				});

			}


			// Generate the breadcrumbs

			var url = '';

			if(filemanager.hasClass('searching')){

				url = '<span>Search results: </span>';
				fileList.removeClass('animated');

			}
			else {

				fileList.addClass('animated');

				breadcrumbsUrls.forEach(function (u, i) {

					var name =	u=="/"
								?	["/"]
								:	u.split('/');
					if (name[0]=="")
						name[0]="/";
					console.log("browseFoldersDialog,render,u="+u+",name=",name);

					if (i !== breadcrumbsUrls.length - 1) {
						url += '<a href="'+u+'"><span class="folderName">' + name[name.length-1] + '</span></a> <span class="arrow">→</span> ';
					}
					else {
						url += '<span class="folderName">' + name[name.length-1] + '</span>';
					}

				});

			}

			console.log("browseFoldersDialog,render,url="+url);
			breadcrumbs.text('').append(url);


			// Show the generated elements

			fileList.css({'display':'inline-block'});

		}


		// This function escapes special html characters in names

		function escapeHTML(text) {
			return text.replace(/\&/g,'&amp;').replace(/\</g,'&lt;').replace(/\>/g,'&gt;');
		}


		// Convert file sizes from bytes to human readable units

		function bytesToSize(bytes) {
			var sizes = ['Bytes', 'KB', 'MB', 'GB', 'TB'];
			if (bytes == 0) return '0 Bytes';
			var i = parseInt(Math.floor(Math.log(bytes) / Math.log(1024)));
			return Math.round(bytes / Math.pow(1024, i), 2) + ' ' + sizes[i];
		}

	});
}

